﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Xml;

using DomainModel;

namespace Console01 {
  class Program {
    static void Main(string[] args) {
      new Program().DoIt();
    }

    private void DoIt() {
      List<State> states = ReadStatesData("states.xml");
      foreach (State aState in states) {
        Console.WriteLine("{0} {1} {2}",aState.Abbrev, aState.Lower49 ? "49-Yes" : "49-No", aState.Name);
      }
      PromptToContinue();
    }

    private static List<State> ReadStatesData(string fileName) {
      // Create an isntance of XmlTextReader and call Read method to read the file
      XmlTextReader textReader = new XmlTextReader(fileName);
      textReader.Read();
      List<State> states = new List<State>();
      while (textReader.Read()) {
        State aState = new State();
        textReader.MoveToElement();
        if (textReader.Name == "State") {
          aState.Abbrev = textReader.GetAttribute("Abbrev").Trim();
          aState.Name = textReader.GetAttribute("Name").Trim();
          aState.Lower49 = Convert.ToBoolean(Convert.ToInt32(textReader.GetAttribute("Lower49")));
          states.Add(aState);
        }
      }
      return states;
    }

    private static string ReadXml(string fileName) {
      // Create an isntance of XmlTextReader and call Read method to read the file
      XmlTextReader textReader = new XmlTextReader(fileName);
      textReader.Read();
      // If the node has value
      StringBuilder sb = new StringBuilder();
      while (textReader.Read()) {
        // Move to fist element
        textReader.MoveToElement();
        sb.Append("XmlTextReader Properties Test");
        sb.Append("===================");
        // Read this element's properties and display them on console
        sb.Append("Name:" + textReader.Name);
        sb.Append("Base URI:" + textReader.BaseURI);
        sb.Append("Local Name:" + textReader.LocalName);
        sb.Append("Attribute Count:" + textReader.AttributeCount.ToString());
        sb.Append("Depth:" + textReader.Depth.ToString());
        sb.Append("Line Number:" + textReader.LineNumber.ToString());
        sb.Append("Node Type:" + textReader.NodeType.ToString());
        sb.Append("Attribute Count:" + textReader.Value.ToString());
      }
      return sb.ToString();
    }

    private void PromptToContinue() {
      Console.WriteLine();
      Console.WriteLine("Press ENTER to continue...");
      Console.ReadLine();
    }

  }
}
