﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Xml;
using IdeaBlade.Core;
using IdeaBlade.Core.DomainServices;

namespace DomainModel {

  [EnableClientAccess]
  public class PocoServiceProvider {

    public PocoServiceProvider() { }

    #region State

    public IEnumerable<State> GetStates() {
      IEnumerable<State> states = ReadStatesData("states.xml");
      return states;
    }

    private static List<State> _states = null;

    private static IEnumerable<State> ReadStatesData(string embeddedFileName) {
      if (_states == null) {

        var stream = ReflectionFns.GetManifestItem(Assembly.GetExecutingAssembly(), embeddedFileName);
        XmlTextReader textReader = new XmlTextReader(stream);
        textReader.Read();
        _states = new List<State>();
        while (textReader.Read()) {
          State aState = new State();
          textReader.MoveToElement();
          if (textReader.Name == "State") {
            aState.Abbrev = textReader.GetAttribute("Abbrev").Trim();
            aState.Name = textReader.GetAttribute("Name").Trim();
            aState.Lower49 = Convert.ToBoolean(Convert.ToInt32(textReader.GetAttribute("Lower49")));
            _states.Add(aState);
          }
        }
      }
      return _states;
    }

    #endregion State
  }
}
