﻿Imports System.Collections
Imports System.Collections.Generic
Imports System.Linq
Imports System.Windows.Controls


Imports IdeaBlade.EntityModel


Partial Public Class MainPage
    Inherits UserControl
    Public Sub New()
        InitializeComponent()
        CreateEntityManager()
        Login()
    End Sub

    Private Sub Login()
        Dim cred = New LoginCredential("demo1", "demo2", "demo3")

        WriteMessage("Logging in ...")

        _mgr.LoginAsync(cred, Sub(args)
                                  If args.Error IsNot Nothing Then
                                      WriteMessage(args.Error.Message)
                                  Else
                                      WriteMessage("Logged in")
                                      LoadData()
                                  End If
                              End Sub, Nothing)
    End Sub

    Private Sub CreateEntityManager()
        _mgr = New EntityManager()
    End Sub

#Region "LoadData"

    Private Sub LoadData()

        _mgr.ExecuteQueryAsync(Of State)(_mgr.States.Where(Function(s) s.Lower49), AddressOf GotStates, Nothing)
    End Sub

    Private Sub GotStates(ByVal op As EntityQueryOperation(Of State))
        _states.Clear()
        If op.Error IsNot Nothing Then
            WriteMessage(op.Error.Message)
        Else
            Dim results = TryCast(op.Results, IEnumerable)
            For Each aState As State In results
                _states.Add(aState)
            Next
            _statesDataGrid.ItemsSource = _states
            ReportFetchCount(results)
        End If
    End Sub

#End Region

    Private Sub ReportFetchCount(ByVal results As IEnumerable)
        If results Is Nothing Then
            WriteMessage("Fetch failed")
        Else
            WriteMessage(String.Format("Retrieved {0} items.", results.Cast(Of [Object])().Count()))
        End If
    End Sub

    Public Sub WriteMessage(ByVal msg As String)
        _statusTextBlock.Text += Environment.NewLine & msg
    End Sub

#Region "Private Fields"
    Private _mgr As EntityManager
    Private _states As New List(Of State)()
#End Region
End Class