﻿Imports System.Collections.Generic
Imports System.Reflection
Imports System.Xml
Imports IdeaBlade.Core
Imports IdeaBlade.Core.DomainServices

<EnableClientAccess()> _
Public Class PocoServiceProvider

  Public Sub New()
  End Sub

#Region "State"

  Public Function GetStates() As IEnumerable(Of State)
    Dim states As IEnumerable(Of State) = ReadStatesData("states.xml")
    Return states
  End Function

  Private Shared _states As List(Of State) = Nothing

  Private Shared Function ReadStatesData(ByVal embeddedFileName As String) As IEnumerable(Of State)
    If _states Is Nothing Then

      Dim stream = ReflectionFns.GetManifestItem(Assembly.GetExecutingAssembly(), embeddedFileName)
      Dim textReader As New XmlTextReader(stream)
      textReader.Read()
      _states = New List(Of State)()
      While textReader.Read()
        Dim aState As New State()
        textReader.MoveToElement()
        If textReader.Name = "State" Then
          aState.Abbrev = textReader.GetAttribute("Abbrev").Trim()
          aState.Name = textReader.GetAttribute("Name").Trim()
          aState.Lower49 = Convert.ToBoolean(Convert.ToInt32(textReader.GetAttribute("Lower49")))
          _states.Add(aState)
        End If
      End While
    End If
    Return _states
  End Function

#End Region

End Class