﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Web
Imports System.Xml


Namespace Console01
    Class Program
        Private Shared Sub Main(ByVal args As String())
            Dim prog As New Program()
            prog.DoIt()

        End Sub

        Private Sub DoIt()
            Dim states As List(Of State) = ReadStatesData("states.xml")
            For Each aState As State In states
                Console.WriteLine("{0} {1} {2}", aState.Abbrev, If(aState.Lower49, "49-Yes", "49-No"), aState.Name)
            Next
            PromptToContinue()
        End Sub

        Private Shared Function ReadStatesData(ByVal fileName As String) As List(Of State)
            ' Create an isntance of XmlTextReader and call Read method to read the file
            Dim textReader As New XmlTextReader(fileName)
            textReader.Read()
            Dim states As New List(Of State)()
            While textReader.Read()
                Dim aState As New State()
                textReader.MoveToElement()
                If textReader.Name = "State" Then
                    aState.Abbrev = textReader.GetAttribute("Abbrev").Trim()
                    aState.Name = textReader.GetAttribute("Name").Trim()
                    aState.Lower49 = Convert.ToBoolean(Convert.ToInt32(textReader.GetAttribute("Lower49")))
                    states.Add(aState)
                End If
            End While
            Return states
        End Function

        Private Shared Function ReadXml(ByVal fileName As String) As String
            ' Create an isntance of XmlTextReader and call Read method to read the file
            Dim textReader As New XmlTextReader(fileName)
            textReader.Read()
            ' If the node has value
            Dim sb As New StringBuilder()
            While textReader.Read()
                ' Move to fist element
                textReader.MoveToElement()
                sb.Append("XmlTextReader Properties Test")
                sb.Append("===================")
                ' Read this element's properties and display them on console
                sb.Append("Name:" & textReader.Name)
                sb.Append("Base URI:" & textReader.BaseURI)
                sb.Append("Local Name:" & textReader.LocalName)
                sb.Append("Attribute Count:" & textReader.AttributeCount.ToString())
                sb.Append("Depth:" & textReader.Depth.ToString())
                sb.Append("Line Number:" & textReader.LineNumber.ToString())
                sb.Append("Node Type:" & textReader.NodeType.ToString())
                sb.Append("Attribute Count:" & textReader.Value.ToString())
            End While
            Return sb.ToString()
        End Function

        Private Sub PromptToContinue()
            Console.WriteLine()
            Console.WriteLine("Press ENTER to continue...")
            Console.ReadLine()
        End Sub

    End Class
End Namespace